//=== BANK =============//============= ARM-MAP MEMORY =================//================ NEURO-MATRIX MAP MEMORY =============//
// IM1-NMC  (256kB)		// (ARM:0x00140000-0x0017ffff)	0x4000(256kB)	//	(NM: 0x00000000-0x0000ffff),	len = 0x00010000;	//		
// IM3-NMC  (256kB)		// (ARM:0x00180000-0x001bffff)	0x4000(256kB)	//	(NM: 0x00010000-0x0001ffff),	len = 0x00010000;	//		
// IM0-ARM	(256kB)		// (ARM:0x00100000-0x0013ffff)	0x4000(256kB)	//	(NM: 0x00040000-0x0004ffff),	len = 0x00010000;	//	
// IM2-ARM	(256kB)		// (ARM:0x80100000-0x8013ffff)	0x4000(256kB)	// 	(NM: 0x20040000-0x2004ffff),	len = 0x00010000;	//	
// EM0-DDR	(16MB)		// (ARM:0x40000000-0x7fffffff) 16MB          	//	(NM: 0x10000000-0x10ffffff),	len = 0x01000000;	//	
// EM1-DDR	(16MB)		// (ARM:0xc0000000-0xcfffffff) 16MB          	// 	(NM: 0x30000000-0x30ffffff),	len = 0x01000000;	//
// BOOT-ROM			// (ARM:0x80000000 0x800fffff)               	//	(NM: 0x20000000,				len = 0x00040000;	//			
// =============================================================================================================================//

//-- ARM SPACE ADDRESS --------------
#define ARM_CELL0           0x80100000
#define ARM_CELL1           0x80100004	
#define ARM_CELL2     	    0x80100008
#define ARM_CELL3           0x8010000C

#define NMC_CELL0           0x80100010
#define NMC_CELL1           0x80100014
#define NMC_CELL2           0x80100018
#define NMC_CELL3       	   0x8010001C

#define ARM2NMC_SYNC0         0x80100020	//        ARM  NM
#define ARM2NMC_SYNC1         0x80100024	//      		 ARM  NM
#define NMC2ARM_SYNC0         0x80100028	//        NM  ARM 
#define NMC2ARM_SYNC1         0x8010002C	//            NM  ARM 

#define DEBUG_DATA     	   0x80100030

#define INPUT_STREAM_ADDR 0xc0000000 	// address of input ac3-stream
#define OUTPUT_SOUND_ADDR 0x40000000	// address to play pcm data

#define HANDSHAKE_MSG 	  0xABCDEF

#define ERROR_MSG		 0xBEDA6406

#ifndef MEM
#define MEM(addr)  (*((unsigned volatile*)(addr)))
#endif

	

	

#define ARM2NM(addr)((int*)(((unsigned)addr)>>2))
#define NM2ARM(addr)((int*)(((unsigned)addr)*4))


#define VIDEO_STREAM_ADDR			0x40200000
#define VIDEO_STREAM_SIZE			10213632
#define VIDEO_STREAM_WIDTH			720
#define VIDEO_STREAM_HEIGHT			576
